import radiusd
import fal_info
import ionas.request as request

from iobase.xmldata import (XmlNode, XmlConfNode)
from product_conf.reqinfo import (Results, ReqTypes)
from fal_msginfo import (Msg,)
from product_conf import (SUDO_CMD,)

NAME_ATTR = "name"
ARGLIST_NAME = "arglist"
ARG_NAME = "arg"
LOG_NAME = "log"
EVENTLOG_XML_TMPL = '<eventlog><log><code>%s</code></log></eventlog>'

def request_entry(fal_pal_cmd, entry, filter_cmd=""):
	"""Send "entry" to "fal/pal_cmd" and return the entry in response data."""
	
	return request.Request(fal_pal_cmd, filter_cmd).request(entry).get_entry()

def save_event_log(msg_code, arg_dict={}):
	"""save event log."""
	
	eventlog_node = XmlNode(EVENTLOG_XML_TMPL % msg_code)
	
	arglist_node = XmlNode(ARGLIST_NAME)
	for arg_name, arg_value in arg_dict.iteritems():
		arglist_node.append_child(ARG_NAME, arg_value, {NAME_ATTR: arg_name})
		eventlog_node.get_node(LOG_NAME).append_child(arglist_node)
	
	entry = request.Entry(ReqTypes.ADD, eventlog_node)
	request_entry(fal_info.FAL_EVENTLOG_PATH, entry, SUDO_CMD)
	return

def python_post_auth_accept(p):
	p = dict((x, y) for x, y in p)
	user_name = p.get("User-Name")
	ip_address = p.get("NAS-IP-Address")
	if p.get("EAP-Type"):
		save_event_log(Msg.MSG_RADIUS_USER_AUTH_SUCCESS,
				{"name": user_name, "ip_address": ip_address})
	else:
		save_event_log(Msg.MSG_RADIUS_MAC_ADDRESS_AUTH_SUCCESS,
				{"mac_address": user_name,
					"ip_address": ip_address})
	return radiusd.RLM_MODULE_OK

def python_post_auth_reject(p):
	p = dict((x, y) for x, y in p)
	user_name = p.get("User-Name")
	ip_address = p.get("NAS-IP-Address")
	if p.get("EAP-Type"):
		save_event_log(Msg.ERR_RADIUS_USER_AUTH_FAIL,
				{"name": user_name, "ip_address": ip_address})
	else:
		save_event_log(Msg.ERR_RADIUS_MAC_ADDRESS_AUTH_FAIL,
				{"mac_address": user_name,
					"ip_address": ip_address})
	return radiusd.RLM_MODULE_OK
